#include <algorithm>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;

struct Node {
	int cat;
	vector<int> next;
	int seq = -1, max_seq = -1;
};

/**
 * Lessons
 *  - BFS/DFS
 *  - Two passes
 */
int main() {

	int n, m;
	cin >> n >> m;

	Node nodes[n];
	for(int i = 0; i < n; i++) {
		cin >> nodes[i].cat;
	}

	for(int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		nodes[a].next.push_back(b);
		nodes[b].next.push_back(a);
	}

	nodes[0].seq = nodes[0].cat;
	queue<Node*> queue;
	queue.push(nodes);
	while(!queue.empty()) {
		Node *add = queue.front();
		queue.pop();

		for(int nbr : add->next) {
			if(nodes[nbr].seq == -1) {
				queue.push(nodes + nbr);
				nodes[nbr].seq = nodes[nbr].cat ? add->seq + 1 : 0;
			}
		}
	}

	nodes[0].max_seq = nodes[0].seq;
	queue.push(nodes);
	int total = 0;
	while(!queue.empty()) {
		Node *add = queue.front();
		queue.pop();

		bool added = false;
		for(int nbr : add->next) {
			if(nodes[nbr].max_seq == -1) {
				queue.push(nodes + nbr);
				nodes[nbr].max_seq = max(add->max_seq, nodes[nbr].seq);
				added = true;
			}
		}
		if(!added && add->max_seq <= m) {
			total++;
		}
	}

	cout << total << '\n';

	return 0;
}

